summaryrefslogtreecommitdiff
path: root/tests/misc/truncate-owned-by-other
diff options
context:
space:
mode:
authorPádraig Brady <P@draigBrady.com>2008-03-28 22:55:31 +0000
committerJim Meyering <meyering@redhat.com>2008-06-06 14:16:45 +0200
commit75e0047c4b916393b6be3cb985c4c4d4a2d1a836 (patch)
treeac520fe47c6ba9fa6a725d47ba6f20eb4be5ddc5 /tests/misc/truncate-owned-by-other
parent74c0bfbc4cf0b38c9c8af7b018f8bbff60da6767 (diff)
downloadcoreutils-75e0047c4b916393b6be3cb985c4c4d4a2d1a836.tar.xz
Add new program: truncate
* AUTHORS: Register as the author * NEWS: Mention this change * README: Add truncate command to list * src/truncate.c: New command * src/Makefile.am: Add truncate command to list to build * src/.gitignore: Add truncate binary to list to ignore * doc/coreutils.texi (truncate invocation): Add truncate info * man/Makefile.am: Add truncate man page to list to build * man/truncate.x: Add truncate man page template * po/POTFILES.in: Add truncate to list to translate * tests/Makefile.am: Add truncate tests * tests/misc/help-version: Add support for new truncate command * tests/misc/truncate-dangling-symlink: check dangling link ok * tests/misc/truncate-dir-fail: ensure dirs fail * tests/misc/truncate-fail-diag: validate messages for missing paths * tests/misc/truncate-fifo: ensure fifos ignored * tests/misc/truncate-no-create-missing: ensure -c option honoured * tests/misc/truncate-overflow: check signed integer overflows * tests/misc/truncate-owned-by-other: root permissions check * tests/misc/truncate-parameters: check invalid parameter combinations * tests/misc/truncate-relative: check invalid relative sizes
Diffstat (limited to 'tests/misc/truncate-owned-by-other')
-rwxr-xr-xtests/misc/truncate-owned-by-other40
1 files changed, 40 insertions, 0 deletions
diff --git a/tests/misc/truncate-owned-by-other b/tests/misc/truncate-owned-by-other
new file mode 100755
index 000000000..a7ad27864
--- /dev/null
+++ b/tests/misc/truncate-owned-by-other
@@ -0,0 +1,40 @@
+#!/bin/sh
+# Demonstrate that "truncate -s0 writable-but-owned-by-other" works.
+
+# Copyright (C) 2008 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ truncate --version
+fi
+
+. $srcdir/envvar-check
+. $srcdir/test-lib.sh
+require_root_
+
+group_num=$(id -g $NON_ROOT_USERNAME)
+
+# Create a file owned by root, and writable by $NON_ROOT_USERNAME.
+echo > root-owned || framework_failure
+chgrp +$group_num . root-owned || framework_failure
+chmod g+w root-owned
+
+# Ensure that the current directory is searchable by $NON_ROOT_USERNAME.
+chmod g+x .
+
+setuidgid $NON_ROOT_USERNAME env PATH="$PATH" truncate -s0 root-owned || fail=1
+
+(exit $fail); exit $fail